// -------------------------------------------------------------------------------
//
// TestMain.CPP                                             Ulrich Mller 21.05.02
//                                                          PCS1700       VC++ 6.0
// Testrahmen VC++ (Konsole) fr umFish30.DLL
// Motor-Funktionen
// Motor an M1 mit Endtaster an E1 und Impulstaster an E2
//          M2                  E3                     E4
//
// -------------------------------------------------------------------------------

#include <Windows.h>
#include <iostream.h>
#include "umFish30VC.H"

int ft;

void main()
{
	cout << "--- umFish30Test gestartet ---" << endl;
	cout << "Version : " << csVersion() << endl;
	
	// --- Verbindung zum Interface

	ft = csOpenInterface(1, 0, 0, 0);  // --- COM1, no AnalogScan, no Slave, default Poll
	if(ft == ftiFehler)
	{
		cout << "InterfaceProblem, Abbruch" << endl;
		return;
	}
	cout << "OpenInterface erfolgreich" << endl;


	// --- Einzeltests, wahlweise Kommentar entfernen -------
	
	// --- zwei Motoren gegenlufig ----
//	csSetMotor(ft, 1, ftiLinks);
//	csSetMotor(ft, 2, ftiRechts);

	// --- zwei Motoren gegenlufig, full Speed -----
//	csSetMotorEx(ft, 1, ftiLinks, 15);
//	csSetMotorEx(ft, 2, ftiRechts, 15);

	// --- zwei Motoren gegenlufig, low/full Speed ---
//	csSetMotorEx(ft, 1, ftiRechts, 3);
//	csSetMotorEx(ft, 2, ftiLinks,  15);

	// --- zwei Motoren gegenlufig, low/full Speed ---
//	csSetMotorsEx(ft, 1+4, 0xC3);


	// --- zwei Motoren im RobMode, full, 24 Impulse ---
//	csRobMotor(ft, 1, ftiLinks, 15, 24);
//	csRobMotor(ft, 2, ftiRechts, 15, 24);

	// --- zwei Motoren im RobMode, low Speed, 24 Impulse ---
//	csRobMotor(ft, 1, ftiLinks, 10, 24);
//	csRobMotor(ft, 2, ftiRechts, 5, 24);

	// --- ein Motor im RobMode, low Speed ---
//  csSetCounter(ft, 2, 24);
//	csRobMotors(ft, 1, 3, 1);
	
	// --- ein Motor im RobMode, WaitForMotor ----
//	int iMot = 1;
//	csRobMotor(ft, iMot, ftiLinks, 10, 124);
//	while(csGetModeStatus(ft, iMot) != 0);

	
	// --- zwei Motoren im RobMode WaitForMotors ---
	csClearCounters(ft);
	csSetCounter(ft, 2, 12);
	csSetCounter(ft, 4, 48);
	csRobMotors(ft, 0x9, 0xF6, 0x11);
	int i, c;
	do	{
		c = 0;
		for(i=1; i<=4; i++) c += csGetModeStatus(ft, i);
	}   while(c);


	// --- Ende -----------------------------------------
	cout << "--- ENDE : E1 true" << endl;
	while(!csGetInput(ft, 1));
	csSetMotors(ft, 0);
	csCloseInterface(ft);
	cout << "--- ENDE --- " << endl;
}