// -----------------------------------------------------------------------------------------
//
// umFish30.H                                                         Ulrich Mller 08.04.02
//                                                                    PCS1700       VC++ 6.0
//
// -----------------------------------------------------------------------------------------

typedef struct {
	HANDLE  hCom;              // --- Handle : COM1-9       ------- HANDLE / OpenFlag --------
	                           //     Handle : LPT1-3 Win9x
	                           //     1      : LPT Win9x
	                           //     hWinRT : LPT WinNT
	                           //     0      : noch nicht geffnet oder Close
	DWORD  PortID;             // --- 0      : COM          ---- IO-Adresse / InterfaceType --
	                           //     1      : LPT WinNT
	                           //     Adr    : LPT Win9x  
	DWORD  LPTDelay;           // --- LPT Verzgerungsfaktor
	DWORD  LPTAnalog;          // --- LPT Analogfaktor 
	DWORD  ECount;             // --- Slave Anzahl Eingnge 8 / 16
	
	MMRESULT FID;              // --- Handle : MultiaMediaTimer
	DWORD    PollInterval;     //     PollInterval des MM-Timers in mSek
	DWORD    AnalogScan;       //     Pollen auch der A-Eingnge (0, 1, 2)

	DWORD  OutputStatus;       // --- Aktueller Status der M-Ausgnge (00 | 01 | 10)
	DWORD  MotorStatus;        //     SollStatus der M-Ausgnge (00 | 01 | 10)
	DWORD  SpeedStatus;        //     Den M-Ausgngen zugeordnete Geschwindigkeit (0-15)
	DWORD  ModeStatus;         //     Den M-Ausgngen zug. Betriebsstatus (0-15)
	DWORD  TaktNr;             //     Aktueller Takt der OnOffTabelle (0-15)
	DWORD  InputStatus;        //     Status der E-Eingnge (0 | 1)
	DWORD  Analogs[2];         //     Werte der A-Eingnge (0 -1024)
	DWORD  Counters[16];       //     Impulszhler an den E-Eingngen ( 0 - ....)
} ftiDCB;

const DWORD ftiAus    = 0;
const DWORD ftiEin    = 1;
const DWORD ftiLinks  = 1;
const DWORD ftiRechts = 2;

const DWORD ftiFehler = 0x0001FFFF;

const DWORD MAus[9]      = {0, 0xFFFC, 0xFFF3, 0xFFCF, 0xFF3F,
														   0xFCFF, 0xF3FF, 0xCFFF, 0x3FFF};
const DWORD MLinks[9]    = {0, 0x1,    0x4,    0x10,   0x40,
                               0x100,  0x400,  0x1000, 0x4000};
const DWORD MRechts[9]   = {0, 0x2,    0x8,    0x20,   0x80,
                               0x200,  0x800,  0x2000, 0x8000};
const DWORD EMaske[17]   = {0, 0x1,    0x2,    0x4,    0x8,
                               0x10,   0x20,   0x40,   0x80,
                               0x100,  0x200,  0x400,  0x800,
                               0x1000, 0x2000, 0x4000, 0x8000}; 
const DWORD SMaske[17]   = {0, 0xF,     0xF0,     0xF00,     0xF000,
						       0xF0000, 0xF00000, 0xF000000, 0xF0000000};
const DWORD OnOffTab[16] = {0x0000, 0x8080, 0x8222, 0x8880,
                            0x88A8, 0xA8A8, 0xAAA8, 0xAAAA,
							0xBAAA, 0xBABA, 0xBABB, 0xBBBB, 
							0xBBBF, 0xBFBF, 0xBFFF, 0xFFFF,};

enum erFehler{erNone, erOpen, erBreak};
enum dwWahr{dwFalse, dwTrue=-1};
enum osSystem{osUnDef, osWin9x, osNT, os2000};

DWORD OpenInterfaceRT(ftiDCB &Interface);
DWORD CloseInterfaceRT(ftiDCB &Interface);
DWORD GetInputsRT(ftiDCB &Interface);
DWORD GetAnalogRT(ftiDCB &Interface, DWORD AnalogNr);
